/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  output2( int i_EVC  , int N_EVC  , double minEV  , \
               TEMP *TP   , double *par, double *BC    , double *d_x   , double *x    , int *i_E, \
               double *REV, double *IEV, double **JREVC, double **JIEVC, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    N_VAR, N, NV, NA, CP;
  double dx;
  N_VAR  =  TP->N_VAR;
  N      =  TP->N;
  NV     =  TP->NV;
  NA     =  TP->NA;
  CP     =  TP->CP;
  dx     =  TP->dx;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, i_VAR;
  int    BF_PForTC, BF_HP;
  double *REVC, *IEVC;
  char   *MEVC, *MSEVC;
  char   *SHELLCOMMAND;
  char   *BF_NAME;
  char   *DIR_SubEVC;
  char   *FILENAME_EVC;
  char   *FILENAME_OPF;
  FILE   *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  REVC          =  malloc_1d( NV+NA     );
  IEVC          =  malloc_1d( NV+NA     );
  MEVC          =  MALLOC_1C( (int)SIZE );
  MSEVC         =  MALLOC_1C( (int)SIZE );
  SHELLCOMMAND  =  MALLOC_1C( (int)SIZE );
  BF_NAME       =  MALLOC_1C( (int)SIZE );
  DIR_SubEVC    =  MALLOC_1C( (int)SIZE );
  FILENAME_EVC  =  MALLOC_1C( (int)SIZE );
  FILENAME_OPF  =  MALLOC_1C( (int)SIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( MEVC, "%s", (char *)MKDIR_EIGENVECTOR );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  if( TP->BF_LABEL == 1  &&  i_EVC == 1 ){
    if( mkdir(MEVC, 0000755)  !=  0 ){
      sprintf( SHELLCOMMAND, "rm -rf %s", MEVC );
      system( SHELLCOMMAND );
      mkdir( MEVC, 0000755 );
    }
  }
  BF_PForTC  =  BF_HP  =  0;
/*********************************************************************************/
  for( i = 1; i <= N_EVC; i++ ){
    if( IEV[i_E[i]]  ==  0.0 )  BF_PForTC ++;
    else                        BF_HP     ++;
  }
/*
  if( TP->np  ==  0 ){
    for( i = 1; i <= N_EVC; i++ ){
      if( IEV[i_E[i]]  ==  0.0 )  BF_PForTC ++;
      else                        BF_HP     ++;
      if(  fabs(REV[i_E[i]])-minEV  <=  MIN_UEV_CHECK  ){
        if( IEV[i_E[i]]  ==  0.0 )  BF_PForTC ++;
        else                        BF_HP     ++;
      }
    }
  }else{
    for( i = 1; i <= N_EVC; i++ ){
      if( IEV[i_E[i]]  ==  0.0 )  BF_PForTC ++;
      else                        BF_HP     ++;
      if(  sqrt(REV[i_E[i]]*REV[i_E[i]]+IEV[i_E[i]]*IEV[i_E[i]])-minEV  <=  MIN_UEV_CHECK  ){
        if( IEV[i_E[i]]  ==  0.0 )  BF_PForTC ++;
        else                        BF_HP     ++;
      }
    }
  }
*/
/*********************************************************************************/
  if     ( BF_PForTC != 0  &&  BF_HP != 0 ){  sprintf( BF_NAME, "%dPForTC_%dHP", BF_PForTC, BF_HP );  TP->BF_TYPE  =  BFT_5;  }
  else if(                     BF_HP >= 2 ){  sprintf( BF_NAME, "%dHP"         ,            BF_HP );  TP->BF_TYPE  =  BFT_4;  }
  else if( BF_PForTC >= 2                 ){  sprintf( BF_NAME, "%dPForTC"     , BF_PForTC        );  TP->BF_TYPE  =  BFT_3;  }
  else if(                     BF_HP == 1 ){  sprintf( BF_NAME, "HP"                              );  TP->BF_TYPE  =  BFT_2;  }
  else if( BF_PForTC == 1                 ){  sprintf( BF_NAME, "PForTC"                          );  TP->BF_TYPE  =  BFT_1;  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  sprintf( DIR_SubEVC, "%d_CP%16.15lf_%s", TP->step, par[CP], BF_NAME );
  if( i_EVC  ==  1 ){
    sprintf( MSEVC, "%s/%s", MEVC, DIR_SubEVC );
    mkdir( MSEVC, 0000755 );
  }
  if( minEV  ==  fabs(REV[i_E[i_EVC]]) ){
    sprintf( FILENAME_EVC, "%s/%s/%d_NZOEVC%16.15lf" , MEVC, DIR_SubEVC, i_EVC, REV[i_E[i_EVC]] );
    sprintf( FILENAME_OPF, "%s/%s/o%d_NZOEVC%16.15lf", MEVC, DIR_SubEVC, i_EVC, REV[i_E[i_EVC]] );
  }else{
    sprintf( FILENAME_EVC, "%s/%s/%d_EVC%16.15lf" , MEVC, DIR_SubEVC, i_EVC, REV[i_E[i_EVC]] );
    sprintf( FILENAME_OPF, "%s/%s/o%d_EVC%16.15lf", MEVC, DIR_SubEVC, i_EVC, REV[i_E[i_EVC]] );
  }
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  FP_W  =  fopen_mode( FILENAME_EVC, WriteMode );
  for( i = 1; i <= N; i++ ){
    fprintf( FP_W, "%7d %10.8lf ", i_EVC, (double)i*dx );
    for( i_VAR = 1; i_VAR <= N_VAR  ; i_VAR++ )  fprintf( FP_W, "%20.15E " , JREVC[(i_VAR-1)*N+i][i_EVC] );
    for( i_VAR = 1; i_VAR <= N_VAR-1; i_VAR++ )  fprintf( FP_W, "%20.15E " , JIEVC[(i_VAR-1)*N+i][i_EVC] );
                                                 fprintf( FP_W, "%20.15E\n", JIEVC[(i_VAR-1)*N+i][i_EVC] );
  }
  fclose( FP_W );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= NV+NA; i++ ){
    REVC[i]  =  JREVC[i][i_EVC];
    IEVC[i]  =  JIEVC[i][i_EVC];
  }
  TP->REV_i_E  =  IEV[i_E[i_EVC]];
  Output_MidleData_EVC( *TP, par, BC, d_x, x, REV, IEV, REVC, IEVC, FILENAME_OPF, WriteMode );
  if( i_EVC  ==  N_EVC )
    TP->BF_LABEL ++;
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
  free_1d( REVC         );
  free_1d( IEVC         );
  FREE_1C( MEVC         );
  FREE_1C( MSEVC        );
  FREE_1C( SHELLCOMMAND );
  FREE_1C( BF_NAME      );
  FREE_1C( DIR_SubEVC   );
  FREE_1C( FILENAME_EVC );
  FREE_1C( FILENAME_OPF );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
