/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  HQR( int Nm    , int N      , int *low   , int *igh, \
           double **a, double *REV, double *IEV, int *ERR  )
{
  int i, j, k, l, m, en, ll, mm, na, itn, its, mp2, enm2;
  int notlas;  // <--logical da!!!!!!!!!!!!!!!!!!!!!!!
  double p, q, r, s, t, w, x, y, zz, norm, tst1, tst2;
/*-------------------------------------------------------------------------------*/

int TTTTT;

/*-------------------------------------------------------------------------------*/
  *ERR  =  0;
  norm  =  0.0;
  k     =  1;
/*- - - - - - store roots isolated by balanc and compute matrix norm  - - - - - -*/
  for( i = 1; i <= N; i++ ){
    for( j = k; j <= N; j++ )
      norm  =  norm + fabs( a[i][j] );
    k  =  i;
    if( i >= *low  &&  i <= *igh )
      goto L50;
    REV[i]  =  a[i][i];
    IEV[i]  =  0.0;
    L50:   // <======== saigo label harenai
    TTTTT=1;  // <-----nantokasinaito!!
  }
  en   =  *igh;
  t    =  0.0;
  itn  =  30 * N;
/*- - - - - - - - - - - - - search for next eigenvalues - - - - - - - - - - - - -*/
  L60:
  if( en < *low )
    return;   //  <-------- saigo no label !!
  its   =  0;
  na    =  en - 1;
  enm2  =  na - 1;
/* - look for single small sub-diagonal element  for l=en step -1 until low do - */
  L70:
  for( ll = *low; ll <= en; ll++ ){
    l  =  en + *low - ll;
    if( l  ==  *low )
      goto L100;
    s  =  fabs( a[l-1][l-1] ) + fabs( a[l][l] );
    if( s  ==  0.0 )
      s = norm;
    tst1  =  s;
    tst2  =  tst1 + fabs( a[l][l-1] );
    if( tst2  ==  tst1 )
      goto L100;
  }
/*- - - - - - - - - - - - - - - - - form shift - - - - - - - - - - - - - - - - - */
  L100:
  x  =  a[en][en];
  if( l  ==  en )
    goto L270;
  y  =  a[na][na];
  w  =  a[en][na] * a[na][en];
  if( l ==  na )
    goto L280;
  if( itn  ==  0 )
    goto L1000;
  if( its != 10  &&  its != 20 )
    goto L130;
/*- - - - - - - - - - - - - - form exceptional shift - - - - - - - - - - - - - - */
  t  =  t + x;
  for( i = *low; i <= en; i++ )
    a[i][i] = a[i][i] - x;
  s  =  fabs( a[en][na] ) + fabs( a[na][enm2] );
  x  =  0.75 * s;
  y  =  x;
  w  =  -0.4375 * s * s;
  L130:
  its  =  its + 1;
  itn  =  itn - 1;
/*- - - look for two consecutive small sub-diagonal elements. 
                                              for m=en-2 step -1 until l do - - -*/
  for( mm = l; mm <= enm2; mm++ ){
    m   =  enm2 + l - mm;
    zz  =  a[m][m];
    r   =  x - zz;
    s   =  y - zz;
    p   =  (r*s-w) / a[m+1][m] + a[m][m+1];
    q   =  a[m+1][m+1] - zz - r - s;
    r   =  a[m+2][m+1];
    s   =  fabs(p) + fabs(q) + fabs(r);
    p   =  p / s;
    q   =  q / s;
    r   =  r / s;
    if( m  ==  l )
      goto L150;
    tst1  =  fabs(p)*(fabs(a[m-1][m-1]) + fabs(zz) + fabs(a[m+1][m+1]));
    tst2  =  tst1 + fabs(a[m][m-1])*(fabs(q)+fabs(r));
    if( tst2  ==  tst1 )
      goto L150;
  }
  L150:
  mp2  =  m + 2;
  for( i = mp2; i <= en; i++ ){
    a[i][i-2]  =  0.0;
    if( i  ==  mp2 )
      goto L160;
    a[i][i-3]  =  0.0;
    L160:
    TTTTT=1;  // <-----nantokasinaito!! //<=------- last label !!
  }
/*- - - - - double qr step involving rows l to en and columns m to en  - - - - - */
  for( k = m; k <= na; k++ ){
    if( k  !=  na )       //  Logical notlas = k .ne. na
      notlas  =  1;
    else
      notlas  =  - 1;
    if( k  ==  m )
      goto L170;
    p  =  a[k][k-1];
    q  =  a[k+1][k-1];
    r  =  0.0;
    if( notlas  ==  1 )
      r  =  a[k+2][k-1];
    x  =  fabs(p) + fabs(q) + fabs(r);
    if( x  ==  0.0 )
      goto L260;
    p  =  p / x;
    q  =  q / x;
    r  =  r / x;
    L170:
    s  =  sqrt(p*p+q*q+r*r);    // <----------dsign!!     
    if( p  <  0 )
      s  *=  - 1.0;
    if( k  ==  m )
      goto L180;
    a[k][k-1]  =  -s * x;
    goto L190;
    L180:
    if( l  !=  m )
      a[k][k-1]  =  - a[k][k-1];
    L190:
    p   =  p + s;
    x   =  p / s;
    y   =  q / s;
    zz  =  r / s;
    q   =  q / p;
    r   =  r / p;
    if( notlas  ==  1 )
      goto L225;
/*- - - - - - - - - - - - - - - - row modification - - - - - - - - - - - - - - - */
    for( j = k; j <= N; j++ ){
      p          =  a[k][j]   + q * a[k+1][j];
      a[k][j]    =  a[k][j]   - p * x;
      a[k+1][j]  =  a[k+1][j] - p * y;
    }
    if( en < k+3 ) //<--------min0 !!
      j  =  en;
    else
      j  =  k+3; 
/*- - - - - - - - - - - - - - - column modification - - - - - - - - - - - - - - -*/
    for( i = 1; i <= j; i++ ){
      p          =  x * a[i][k] + y * a[i][k+1];
      a[i][k]    =  a[i][k] - p;
      a[i][k+1]  =  a[i][k+1] - p * q;
    }
    goto L255;
    L225:
/*- - - - - - - - - - - - - - - - row modification - - - - - - - - - - - - - - - */
    for( j = k; j <= N; j++ ){
      p          =  a[k][j] + q * a[k+1][j] + r * a[k+2][j];
      a[k][j]    =  a[k][j] - p * x;
      a[k+1][j]  =  a[k+1][j] - p * y;
      a[k+2][j]  =  a[k+2][j] - p * zz;
    }
    if( en < k+3 ) //<--------min0 !!
      j  =  en;
    else
      j  =  k+3; 
/*- - - - - - - - - - - - - - - column modification - - - - - - - - - - - - - - -*/
    for( i = 1; i <= j; i++ ){
      p          =  x * a[i][k] + y * a[i][k+1] + zz * a[i][k+2];
      a[i][k]    =  a[i][k] - p;
      a[i][k+1]  =  a[i][k+1] - p * q;
      a[i][k+2]  =  a[i][k+2] - p * r;
    }
    L255:
    TTTTT=1;  // <-----nantokasinaito!! //<=------- last label !!
    L260:
    TTTTT=1;  // <-----nantokasinaito!! //<=------- last label !!
  }
  goto L70;
/*- - - - - - - - - - - - - - - - ont root found - - - - - - - - - - - - - - - - */
  L270:
  REV[en]  =  x + t;
  IEV[en]  =  0.0;
  en      =  na;
  goto L60;
/*- - - - - - - - - - - - - - - - two roots found - - - - - - - - - - - - - - - -*/
  L280:
  p   =  (y - x) / 2.0;
  q   =  p * p + w;
  zz  =  sqrt( fabs(q) );
  x   =  x + t;
  if( q  <  0.0 )
    goto L320;
/*- - - - - - - - - - - - - - - - - real pair - - - - - - - - - - - - - - - - - -*/
  zz  =  fabs(zz);
  if( p < 0 )
    zz  *=  -1.0;
  zz     +=  p;
  REV[na]  =  x + zz;
  REV[en]  =  REV[na];
  if( zz  !=  0.0 )
    REV[en] = x - w / zz;
  IEV[na]  =  0.0;
  IEV[en]  =  0.0;
  goto L330;
/*- - - - - - - - - - - - - - - - complex pair - - - - - - - - - - - - - - - - - */
  L320:
  REV[na]  =  x + p;
  REV[en]  =  x + p;
  IEV[na]  =   zz;
  IEV[en]  =  -zz;
  L330:
  en  =  enm2;
  goto L60;
/*- - set error -- all eigenvalues have not converged after 30*N iterations - - -*/
  L1000:
  *ERR  =  en;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
