/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Parameter_OutPut( TEMP TP, double *par )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  printf( "                                                                 \n" );
  printf( "-----------------------------------------------------------------\n" );
  printf( " N                   =  %d     \n", TP.N                             );
  printf( " ds                  =  %10.8lf\n", TP.ds                            );
  printf( " Lx                  =  %10.8lf\n", TP.Lx                            );
  printf( " dx                  =  %10.8lf\n", TP.dx                            );
  if( TP.np  ==  1 ){
    printf( " dt                  =  %10.8lf\n", TP.dt                          );
    printf( " N_MSM               =  %d     \n", TP.NM                          );
    printf( " Period Fix          =  %d     \n", TP.PF                          );
  }
  printf( " PseudoNewton        =  %10.8lf\n", TP.PN                            );
  printf( " KellerEqn_SELECT    =  %d     \n", TP.KE                            );
  printf( " MaxIteration        =  %d     \n", TP.MI                            );
  printf( " ControlParameter    =  %d     \n", TP.CP                            );
  printf( " SolutionSELECT      =  %d     \n", TP.SS                            );
  printf( " BC_SELECT           =  %d     \n", TP.BCS                           );
  printf( " EE_SELECT           =  %d     \n", TP.EES                           );
  if( TP.EES == EES_S_E  ||  TP.EES == EES_S_R  ||  TP.EES == EES_S_E_M  ||  TP.EES == EES_S_R_M )
  printf( " NUMBER_WAVE         =  %d     \n", TP.NW                            );
  printf( " EigenValue_SELECT   =  %d     \n", TP.EVS                           );
  printf( " EigenVector_SELECT  =  %d     \n", TP.EVCS                          );
  printf( " StepCut             =  %d     \n", TP.StepCut                       );
  printf( " MaxStep             =  %d     \n", TP.MaxStep                       );
  printf( " GNUPLOT_SELECT      =  %d     \n", TP.GS                            );
  printf( " INITIAL_SELECT      =  %d     \n", TP.IS                            );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  int i;
  for( i = 1; i <= TP.N_EP; i++ )
    printf( " par[%d]  =  %10.8lf\n", i, par[i]                                 );
  printf( "-----------------------------------------------------------------\n" );
  printf( "                                                                 \n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
