/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Reaction( TEMP TP, double *par, double *x, double *F )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  int N = TP.N;
  for( i = 1; i <= N; i++ ){
    F[i  ]  =  par[4]*x[i]*(x[i]-par[5])*(1.0-x[i]) - par[3]*x[i]*x[i+N];
    F[i+N]  =  par[3]*x[i]*x[i+N] - par[6]*x[i+N]; 
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  Diffusion( TEMP TP, double *par )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  par[TP.N_EP+1]  =  (4.0*M_PI*M_PI*par[1]) / (par[7]*par[7]);
  par[TP.N_EP+2]  =  (4.0*M_PI*M_PI*par[2]) / (par[7]*par[7]);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
