/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  BALANC( int Nm, int N, double **A, int *low, int *igh )
{
  int i, j, k, l, m, jj, IEXC;
  double C, F, G, R, S, B2, RADIX;
  int NOCONV;  // <=== ato de nanntoka sinaito
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  double *SCALE;
  SCALE  =  alloc_1d_double( Nm );
/*-------------------------------------------------------------------------------*/

int TTTTT;

/*-------------------------------------------------------------------------------*/
  RADIX =  16.0;
  B2    =  RADIX * RADIX;
  k     =  1;
  l     =  N;
  goto L100;
/* - - - - - - - - IN-LINE PROCEDURE FOR ROW AND COLUMN EXCHANGE - - - - - - - - */
  L20:
  SCALE[m] = j;
  if( j  ==  m )
    goto L50;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= l; i++ ){
    F        =  A[i][j];
    A[i][j]  =  A[i][m];
    A[i][m]  =  F;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = k; i <= N; i++ ){
    F        =  A[j][i];
    A[j][i]  =  A[m][i];
    A[m][i]  =  F;
  }
  L50:
  switch( IEXC ){  // <== syokikasitenai dousureba??
    case 1:
      goto L80;
      break;
    case 2:
      goto L130;
      break;
  }
/*- - - - - SEARCH FOR ROWS ISOLATING AN EIGENVALUE AND PUSH THEM DOWN - - - - - */
  L80:
  if( l  ==  1 )
    goto L280;
  l = l - 1;
/*- - - - - - - - - - - - - FOR J=L STEP -1 UNTIL 1 DO - - - - - - - - - - - - - */
  L100:
  for( jj = 1; jj <= l; jj++ ){
    j = l + 1 - jj;
    for( i = 1; i <= l; i++ ){
      if( i  ==  j )
        goto L110;
      if( A[j][i]  !=  0.0 )
        goto L120;
      L110:
      TTTTT=1;; // <------- nantokasinaito!!-
    }
    m    =  l;
    IEXC =  1;
    goto L20;
    L120:
    TTTTT=1;; // <------- nantokasinaito!!-
  }
  goto L140;
/*- - - - SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE AND PUSH THEM LEFT - - - - -*/
  L130:
  k = k + 1;
  L140:
  for( j = k; j <= l; j++ ){
    for( i = k; i <= l; i++ ){
      if( i  ==  j )
        goto L150;
      if( A[i][j]  !=  0.0 )
        goto L170;
      L150:
      TTTTT=1;; // <------- nantokasinaito!!-
    }
    m     =  k;
    IEXC  =  2;
    goto L20;
    L170:
    TTTTT=1;; // <------- nantokasinaito!!-
  }
/* - - - - - - - - - NOW BALANCE THE SUBMATRIX IN ROWS K TO L - - - - - - - - - -*/
  for( i = k; i <= l; i++ )
    SCALE[i]  =  1.0;
/*- - - - - - - - - - - ITERATIVE LOOP FOR NORM REDUCTION - - - - - - - - - - - -*/
  L190:
  NOCONV  =  -1;  // <----.FALSE.
  for( i = k; i <= l; i++ ){
    C  =  0.0;
    R  =  0.0;
    for( j = k; j <= l; j++ ){
      if( j  ==  i )
        goto L200;
      C  =  C + fabs( A[j][i] );
      R  =  R + fabs( A[i][j] );
      L200:
      TTTTT=1;; // <------- nantokasinaito!!-
    }
/*- - - - - - - - - GUARD AGAINST ZERO C OR R DUE TO UNDERFLOW - - - - - - - - - */
    if( C == 0.0  ||  R == 0.0 )
      goto L270;
    G  =  R / RADIX;
    F  =  1.0;
    S  =  C + R;
    L210:
    if( C  >=  G )
      goto L220;
    F  =  F * RADIX;
    C  =  C * B2;
    goto L210;
    L220:
    G  =  R * RADIX;
    L230:
    if( C < G )
      goto L240;
    F = F / RADIX;
    C = C / B2;
    goto L230;
/*- - - - - - - - - - - - - - - - - NOW BALANCE - - - - - - - - - - - - - - - - -*/
    L240:
    if( (C+R)/F  >=  0.95*S )
      goto L270;
    G  =  1.0 / F;
    SCALE[i]  =  SCALE[i] * F;
    NOCONV  =  1;  // <=--TRUE
    for( j = k; j <= N; j++ )
      A[i][j]  =  A[i][j] * G;
    for( j = 1; j <= l; j++ )
      A[j][i]  =  A[j][i] * F;
    L270:
    TTTTT=1;; // <------- nantokasinaito!!-
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( NOCONV == 1 )  // <--- NOCONV=1(TRUE) nara zikkou
    goto L190;
  L280:
  *low  =  k;
  *igh  =  l;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( SCALE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
