/*-------------------------------------------------------------------------------*/
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_1n3pDN
      ( int N, double *RS, double **L, double **U, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double *z;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  z  =  alloc_1d_double( N+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  z[1]  =  RS[1] / L[1][1];
  for( i = 2; i <= N; i++ )
    z[i]  =  ( RS[i] - L[2][i] * z[i-1] ) / L[1][i];

  x[N]  =  z[N];
  for( i = N-1; i >= 1; i-- )
    x[i]  =  z[i] - U[1][i] * x[i+1];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( z );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
