/*-------------------------------------------------------------------------------*/
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_1nF( int N, double *RS, double **L, double **U, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
  double sum;
  double *z;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  z  =  alloc_1d_double( N+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  z[1]  =  RS[1];
  for( i = 2; i <= N; i++ ){
    sum  =  0.0;
    for( j = 1; j <= i-1; j++ )
      sum  +=  L[i][j] * z[j];
    z[i]  =  RS[i] - sum;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  x[N]  =  z[N] / U[N][N];
  for( i = N-1; i >= 1; i-- ){
    sum  =  0.0;
    for( j = i+1; j <= N; j++ )
      sum  +=  U[i][j] * x[j];
    x[i]  =  (z[i] - sum) / U[i][i];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( z );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
