/*-------------------------------------------------------------------------------*/
void  Arrange_SV( int N, int Nm , int nm, int NN, int NM, int BCS, \
                  double BC_00_U, double BC_N1_U, double BC_00_V , double BC_N1_V, \
                  double *x     , double *xx      )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( BCS  ==  1 ){
    i  =  1;
    xx[i   ]  =  BC_00_U;
    xx[i+NN]  =  BC_00_V;
    for( i = 2; i <= NN-1; i++ ){
      xx[i   ]  =  x[i-1  ];
      xx[i+NN]  =  x[i-1+N];
    }
    i  =  NN;
    xx[i   ]  =  BC_N1_U;
    xx[i+NN]  =  BC_N1_V;
  }else if( BCS  ==  2 ){
    for( i = 1; i <= NN; i++ ){
      xx[i   ]  =  x[i  ];
      xx[i+NN]  =  x[i+N];
    }
  }else if( BCS  ==  3 ){
    for( i = 1; i <= NN-1; i++ ){
      xx[i   ]  =  x[i  ];
      xx[i+NN]  =  x[i+N];
    }
    i  =  NN;
    xx[i   ]  =  x[i  -N];
    xx[i+NN]  =  x[i+N-N];
  }
  for( i = 1; i <= nm; i++ )
    xx[NM+i]  =  x[Nm+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  Arrange_SV1( int N, int Nm, int nm, int NN, int NM, int BCS, double *xx, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( BCS  ==  1 ){
    for( i = 1; i <= N; i++ ){
      x[i  ]  =  xx[i+1   ];
      x[i+N]  =  xx[i+1+NN];
    }
  }else if( BCS  ==  2 ){
    for( i = 1; i <= N; i++ ){
      x[i  ]  =  xx[i   ];
      x[i+N]  =  xx[i+NN];
    }
  }else if( BCS  ==  3 ){
    for( i = 1; i <= N; i++ ){
      x[i  ]  =  xx[i   ];
      x[i+N]  =  xx[i+NN];
    }
  }
  for( i = 1; i <= nm; i++ )
    x[Nm+i]  =  xx[NM+i];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
