/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "StructType_Definition.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  M_Delete( int DEL_ROW_A, int DEL_COL_A, int MAX_A, double *RS, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= DEL_ROW_A-1; i++ ){
    for( j = DEL_COL_A+1; j <= MAX_A; j++ ){
      a[i][j-1]  =  a[i][j];
      a[i][j  ]  =  0.0;
    }
  }
  for( i = DEL_ROW_A+1; i <= MAX_A; i++ ){
    for( j = 1; j <= DEL_COL_A-1; j++ ){
      a[i-1][j]  =  a[i][j];
      a[i  ][j]  =  0.0;
    }
  }
  for( i = DEL_ROW_A+1; i <= MAX_A; i++ ){
    for( j = DEL_COL_A+1; j <= MAX_A; j++ ){
      a[i-1][j-1]  =  a[i][j];
      a[i  ][j  ]  =  0.0;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  RS_Delete( int DEL_ROW_A, int MAX_A, double *RS )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = DEL_ROW_A+1; i <= MAX_A; i++ )
    RS[i-1]  =  RS[i];
  RS[MAX_A]  =  0.0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  IP_Addition( int DEL_ROW_A, int MAX_A, int *IP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  for( i = MAX_A-1; i >= DEL_ROW_A; i-- )
    IP[i+1]  =  IP[i];
  IP[DEL_ROW_A]  =  MAX_A;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
