/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "function_declartion.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  normalize_dot_x( int N, double *d_x, int *I_ERR )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  *I_ERR  =  0;
  sum     =  0.0;
  for( i = 1; i <= N; i++ )
    sum  +=  d_x[i] * d_x[i];
  if( sum  !=  0.0 ){
    for( i = 1; i <= N; i++ )
      d_x[i]  /=  sqrt( sum );
  }else{
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Sum Direction Vector divide by 0 !!\n" );
    END_PROGRAM( PRINTF, 10, 0 );
    *I_ERR  =  1;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
