/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_1n3dDNC( TEMP TP, double **a )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, Vi, i_VAR;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP.BCS == 1  ||  TP.BCS == 2  ||  TP.BCS == 4 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ ){
        a[3][i  ]  =  a[3][i] / a[1][i];
        a[1][i+1]  =  a[1][i+1] - a[3][i] * a[2][i+1];
      }
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( TP.BCS  ==  3 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      a[3][1+Vi]  =  a[3][1+Vi] / a[1][1+Vi];
      a[5][1+Vi]  =  a[5][1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N-2+Vi; i++ ){
        a[1][i]  =  a[1][i] - a[3][i-1]*a[2][i];
        a[3][i]  =  a[3][i] / a[1][i];
        a[5][i]  =  - a[2][i] * a[5][i-1] / a[1][i];
      }
      i        =  TP.N-1+Vi;
      a[1][i]  =  a[1][i] - a[3][i-1]*a[2][i];
      a[5][i]  =  ( a[3][i]-a[2][i]*a[5][i-1] ) / a[1][i];
      for( i = 2+Vi; i <= TP.N-2+Vi; i++ )
        a[4][i]  =  - a[3][i-1] * a[4][i-1];
      i = TP.N-1+Vi;
      a[4][i] = a[2][TP.N+Vi] - a[3][i-1] * a[4][i-1];   
      sum  =  0.0;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ )
        sum  +=  a[4][i] * a[5][i];
      a[4][TP.N+Vi]  =  a[1][TP.N+Vi] - sum;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
