/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Output_Final( TEMP TP, double *par, double *BC, double *x, char *FILENAME, int WriteMode )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  double *SOP, *EP, *xx;
  FILE   *FP_W;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP  =  malloc_1d( TP.N_VAR*TP.Ns+TP.NA );
  EP   =  malloc_1d( TP.N_VAR*TP.Ns+TP.NA );
  xx   =  malloc_1d( TP.N_VAR*TP.Ns+TP.NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  x[TP.NV+1]  =  0.0;
  x[TP.NV+2]  =  TP.AveVel_C;
  x[TP.NV+3]  =  0.0;
  Generate_OPEP( TP, par, BC, SOP, EP );
  Generate_tSV( TP, BC, x, xx );
  FP_W  =  fopen_mode( FILENAME, WriteMode );
  for( i = 1; i <= TP.N_VAR*TP.Ns+TP.NA; i++ )
    fprintf( FP_W, "%7d %20.15E %20.15E %20.15E %20.15E\n", \
             TP.step, SOP[i], EP[i], 0.0, xx[i] );
  fclose( FP_W );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( SOP );
  free_1d( EP  );
  free_1d( xx  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
