/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "StructType_Definition.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Parameter_OutPut( TEMP TP, double *par )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  printf( "                                                                 \n" );
  printf( "-----------------------------------------------------------------\n" );
  printf( " N                  =  %d     \n", TP.N                              );
  if( TP.EES == EES_S_E  ||  TP.EES == EES_S_R )
  printf( " NUMBER_WAVE        =  %d     \n", TP.NW                             );
  printf( " dt                 =  %10.8lf\n", TP.dt                             );
  printf( " dx                 =  %10.8lf\n", TP.dx                             );
  printf( " Lx                 =  %10.8lf\n", TP.Lx                             );
  printf( " G_CutN_Vel_Dis     =  %d     \n", TP.GCNVD                          );
  printf( " Velocity_Site      =  %10.8lf\n", TP.Vel_Site                       );
  printf( " Vel_Measure_Start  =  %d     \n", TP.VMS                            );
  printf( " BC_SELECT          =  %d     \n", TP.BCS                            );
  printf( " EE_SELECT          =  %d     \n", TP.EES                            );
  printf( " StepCut            =  %d     \n", TP.StepCut                        );
  printf( " MaxStep            =  %d     \n", TP.MaxStep                        );
  printf( " GNUPLOT_SELECT     =  %d     \n", TP.GS                             );
  printf( " INITIAL_SELECT     =  %d     \n", TP.IS                             );
  printf( "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n" );
  int i;
  for( i = 1; i <= TP.N_EP; i++ )
    printf( " par[%d]  =  %10.8lf\n", i, par[i]                                 );
  printf( "-----------------------------------------------------------------\n" );
  printf( "                                                                 \n" );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void  Round_Off( int NM, int cMP, TEMP TP, int *point );
void  Round_Off( int NM, int cMP, TEMP TP, int *point ){   point[1] = point[2] = 1;   }
/*-------------------------------------------------------------------------------*/
