/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
/*#include "/usr/local/include/glsc.h"*/
#include "glsc.h"
#include "function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  LINESIZE      300
#define  METASIZE      300
#define  COMMANDSIZE    50
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
int  main( int argc, char **argv )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i = 1;
  int     IS            =  atoi( argv[i++] );   //  Initial Select
  int     OPCD          =  atoi( argv[i++] );   //  OutPut Cut Data
  int     DP            =  atoi( argv[i++] );   //  Divison Point
  int     USVP          =  atoi( argv[i++] );   //  U SolutionValue Point
  int     VSVP          =  atoi( argv[i++] );   //  V SolutionValue Point
  double  Dx_Zbottom_U  =  atof( argv[i++] );
  double  Dx_Ztop_U     =  atof( argv[i++] );
  double  Dx_Zbottom_V  =  atof( argv[i++] );
  double  Dx_Ztop_V     =  atof( argv[i++] );
  int     Win_Wid       =  atoi( argv[i++] );
  int     Win_High      =  atoi( argv[i++] );
  double  Marg_Wid      =  atof( argv[i++] );
  double  Marg_High     =  atof( argv[i++] );
  double  Dom_xmin      =  atof( argv[i++] );
  double  Dom_xmax      =  atof( argv[i++] );
  double  Dom_ymin      =  atof( argv[i++] );
  double  Dom_ymax      =  atof( argv[i++] );
  double  Graph_X       =  atof( argv[i++] );
  double  Graph_Y       =  atof( argv[i++] );
  double  Graph_Z       =  atof( argv[i++] );
  double  Distance      =  atof( argv[i++] );
  double  Theta         =  atof( argv[i++] );
  double  Phi           =  atof( argv[i++] );
  int     Direction     =  atoi( argv[i++] );
  int     Side_Paint    =  atoi( argv[i++] );
  int     xstep         =  atoi( argv[i++] );
  int     ystep         =  atoi( argv[i++] );
  char    *MD           =        argv[i++]  ;   //  Making Directory
  char    *RD           =        argv[i++]  ;   //  Read Data
  char    *METAFILE1    =        argv[i++]  ;
  char    *METAFILE2    =        argv[i++]  ;
  char    *METAFILE3    =        argv[i++]  ;
  char    *SC_D         =        argv[i++]  ;   //  Split_Character_Data;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( IS  ==  1  ||  IS  ==  4 ){
  }else if( IS  ==  2 ){
    VSVP  =  USVP;
  }else if( IS  ==  3 ){
    USVP  =  VSVP;
  }else{
    printf( "Mistake Initial Select !! (IS)\n" );
    exit(1);
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int NumData;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  DataNum( RD, &NumData );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int  N_SD;   //  Num_Split_Data
  char *t_line;
  FILE *FP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_line  =  alloc_1d_char( (int)LINESIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_R  =  fopen_mode( RD, 'r' );
  fgets( t_line, LINESIZE, FP_R );
  fclose( FP_R );
  N_SPLIT( SC_D, t_line, &N_SD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char( t_line );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int    NX;
  int    NY;
  double p_DPV, DPV;
  double *data;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  data  =  alloc_1d_double( N_SD+1 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_R  =  fopen_mode( RD, 'r' );
  SPLIT_READ_DATA( N_SD, FP_R, data );
  p_DPV  =  DPV  =  data[DP];
  NX    =  1;
  while( 1 ){
    SPLIT_READ_DATA( N_SD, FP_R, data );
    if( feof(FP_R)  !=  0 ){
      fclose( FP_R );
      printf( "                              \n"     );
      printf( "There are few Data to Read(%s)\n", RD );
      printf( "There are few Data to Read(%s)\n", RD );
      printf( "There are few Data to Read(%s)\n", RD );
      printf( "There are few Data to Read(%s)\n", RD );
      printf( "There are few Data to Read(%s)\n", RD );
      printf( "                              \n"     );
      return 0;
    }
    DPV  =  data[DP];
    if( p_DPV  !=  DPV )
      break;
    p_DPV  =  DPV;
    NX ++;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  NY  =  NumData / NX;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( xstep  ==  -1 )
    xstep  =  NX;
/*-------------------------------------------------------------------------------*/
   
/*-------------------------------------------------------------------------------*/
  int j, ii, jj;
  int ny;
  double MAX_U=0.0, MIN_U=0.0;
  double MAX_V=0.0, MIN_V=0.0;
//  double **u;
//  double **v;
  ny  =  0;
  if( NY % OPCD  !=  0 )
    ny  = 1;
  double u[NX][NY/OPCD+ny];
  double v[NX][NY/OPCD+ny];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//  u  =  alloc_2d_double( NX, NY/OPCD+ny );
//  v  =  alloc_2d_double( NX, NY/OPCD+ny );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FP_R  =  fopen_mode( RD, 'r' );
  SPLIT_READ_DATA( N_SD, FP_R, data );
  MAX_U  =  MIN_U  =  u[0][0]  =  data[USVP];
  MAX_V  =  MIN_V  =  v[0][0]  =  data[VSVP];
  fclose( FP_R );
  FP_R  =  fopen_mode( RD, 'r' );
  for( j = 0; j <= NY/OPCD+ny-1; j++ ){
    for( i = 0; i <= NX-1; i++ ){
      SPLIT_READ_DATA( N_SD, FP_R, data );
      u[i][j]  =  data[USVP];
      v[i][j]  =  data[VSVP];
      if( MAX_U  <  u[i][j] )  MAX_U  =  data[USVP];
      if( MIN_U  >  u[i][j] )  MIN_U  =  data[USVP];
      if( MAX_V  <  v[i][j] )  MAX_V  =  data[VSVP];
      if( MIN_V  >  v[i][j] )  MIN_V  =  data[VSVP];
    }
    for( ii = 2; ii <= OPCD; ii++ ){
      if( feof(FP_R)  !=  0 )
        goto END;
      for( jj = 1; jj <= NX; jj++ )
        SPLIT_READ_DATA( N_SD, FP_R, data );
    }
    if( feof(FP_R)  !=  0 )
      goto END;
  }
  END:
  fclose( FP_R );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  double  Zbottom_U, Ztop_U;
  double  Zbottom_V, Ztop_V;
  char    *SHELLCOMMAND;
  char    *METAFILE;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SHELLCOMMAND  =  alloc_1d_char( COMMANDSIZE );
  METAFILE      =  alloc_1d_char( METASIZE    );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
MAX_V=0.25;
printf("%lf\n",MAX_U);
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change \ / */
MAX_U=0.3;
/****change  /\ */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
/****change  |  */
  Zbottom_U  =  MIN_U + Dx_Zbottom_U;
  Ztop_U     =  MAX_U + Dx_Ztop_U;
  Zbottom_V  =  MIN_V + Dx_Zbottom_V;
  Ztop_V     =  MAX_V + Dx_Ztop_V;
/*Zbottom_V=0.17;*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( IS == 1  ||  IS == 4 ){
    sprintf( METAFILE, "%s/%s", MD, METAFILE1 );
    g_init( METAFILE, 2.0*Win_Wid+3.0*Marg_Wid, Win_High+2.0*Marg_High );
    g_def_scale( 0, Dom_xmin, Dom_xmax , Dom_ymin, Dom_ymax, \
                    Marg_Wid, Marg_High, Win_Wid , Win_High    ); 
    g_device( G_BOTH ); 
    g_hidden( Graph_X     , Graph_Y, Graph_Z   , Zbottom_U, Ztop_U  , \
              Distance    , Theta  , Phi       ,                      \
              Marg_Wid             , Marg_High , Win_Wid  , Win_High, \
              (G_REAL *) u, NX     , NY/OPCD+ny, Direction,           \
  	      Side_Paint  , xstep  , ystep                              ); 
    g_hidden( Graph_X     , Graph_Y, Graph_Z   , Zbottom_V, Ztop_V  , \
              Distance    , Theta  , Phi       ,                      \
              Win_Wid+2.0*Marg_Wid , Marg_High , Win_Wid  , Win_High, \
              (G_REAL *) v, NX     , NY/OPCD+ny, Direction,           \
  	      Side_Paint  , xstep  , ystep                              ); 
    g_sleep( G_STOP );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( IS == 2  ||  IS == 4 ){
    sprintf( METAFILE, "%s/%s", MD, METAFILE2 );
    g_init( METAFILE, 2.0*Win_Wid+3.0*Marg_Wid, Win_High+2.0*Marg_High );
    g_device( G_BOTH ); 
    g_cls();
    g_hidden( Graph_X     , Graph_Y  , Graph_Z   , Zbottom_U, Ztop_U  , \
              Distance    , Theta    , Phi       ,                      \
              Marg_Wid    , Marg_High, 2.0*Win_Wid+Marg_Wid , Win_High, \
              (G_REAL *) u, NX       , NY/OPCD+ny, Direction,           \
  	      Side_Paint  , xstep    , ystep                              ); 
    g_sleep( G_STOP );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( IS == 3  ||  IS == 4 ){
    sprintf( METAFILE, "%s/%s", MD, METAFILE3 );
    g_init( METAFILE, 2.0*Win_Wid+3.0*Marg_Wid, Win_High+2.0*Marg_High );
    g_device( G_BOTH ); 
    g_cls();
    g_hidden( Graph_X     , Graph_Y  , Graph_Z   , Zbottom_V, Ztop_V  , \
              Distance    , Theta    , Phi       ,                      \
              Marg_Wid    , Marg_High, 2.0*Win_Wid+Marg_Wid , Win_High, \
              (G_REAL *) v, NX       , NY/OPCD+ny, Direction,           \
  	      Side_Paint  , xstep    , ystep                              ); 
    g_sleep( G_STOP );
/*
    sprintf( SHELLCOMMAND, "cd %s; g_out -i %s; ps2epsi %s.i00\n", MD, METAFILE3, METAFILE3 );  system( SHELLCOMMAND );
*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char( SHELLCOMMAND );
  free_1d_char( METAFILE     );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
