/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "function_declartion.h"
#include "StructType_Definition.h"
#include "constant.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  TEMPDATASIZE  300
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  DataNum( char *READ_DATA, int *DataNum ) 
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *buff;
  FILE *FP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  buff  =  MALLOC_1C( TEMPDATASIZE );
/*-------------------------------------------------------------------------------*/
  
/*-------------------------------------------------------------------------------*/
  FP_R  =  fopen( READ_DATA, "r" );
  if( FP_R  ==  NULL ){
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Open Error !!\n" );
    END_PROGRAM( PRINTF, 10, 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *DataNum  =  0;
  while( fgets( buff, TEMPDATASIZE, FP_R )  !=  NULL )
    (*DataNum) ++;
  fclose( FP_R );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( buff );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  DataNum1( TEMP *TP, char *READ_DATA, int *DataNum )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_S, NVs, NA;
  N_S  =  TP->N_S;
  NVs  =  TP->N_VAR*TP->Ns;
  NA   =  TP->NA;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, LSOPNM, NSSOL, NSEV, N_READ, MAX_NM, NM, ti;
  double td, dNM;
  char   *buff;
  FILE   *FP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  LSOPNM  =  (int)L_SOP_NM;
  NSSOL   =  (int)N_S_SOL;
  NSEV    =  (int)N_S_EV;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  *DataNum  =  0;
  MAX_NM    =  0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  buff  =  MALLOC_1C( TEMPDATASIZE );
/*-------------------------------------------------------------------------------*/
  
/*-------------------------------------------------------------------------------*/
  FP_R  =  fopen( READ_DATA, "r" );
  if( FP_R  ==  NULL ){
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Open Error !!\n" );
    END_PROGRAM( PRINTF, 10, 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( N_S  ==  NSSOL ){
    while( 1 ){
      for( i = 1; i <= LSOPNM-1; i++ )
        if( fgets( buff, TEMPDATASIZE, FP_R )  ==  NULL   )   goto END;
      fscanf( FP_R, "%d %lf %lf %lf %lf\n", &ti, &dNM, &td, &td, &td );
      NM  =  (int)dNM;
      if( NM <= 0 )   goto END;
      else            N_READ  =  NM*NVs+NA - LSOPNM;
      for( i = 1; i <= N_READ; i++ )
        if( fgets( buff, TEMPDATASIZE, FP_R )  ==  NULL   )   goto END;
      (*DataNum) += NVs+NA;
      if( MAX_NM <= NM )   MAX_NM = NM;
    }
  }else if( N_S  ==  NSEV ){
    while( 1 ){
      for( i = 1; i <= LSOPNM-1; i++ )
        if( fgets( buff, TEMPDATASIZE, FP_R )  ==  NULL   )   goto END;
      fscanf( FP_R, "%d %lf %lf %lf %lf %lf %lf\n", &ti, &dNM, &td, &td, &td, &td, &td );
      NM  =  (int)dNM;
      N_READ  =  NM*NVs+NA   - LSOPNM;
      if( NM <= 0 )   goto END;
      else            N_READ  =  NM*NVs+NA - LSOPNM;
      for( i = 1; i <= N_READ; i++ )
        if( fgets( buff, TEMPDATASIZE, FP_R )  ==  NULL   )   goto END;
      (*DataNum) += NVs+NA;
      if( MAX_NM <= NM )   MAX_NM = NM;
    }
  }else{
    fclose( FP_R );
    FREE_1C( buff );
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "N_S Mistake !! (%d)\n", N_S );
    END_PROGRAM( PRINTF, 10, 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  END:
  TP->MAX_NM  =  TP->tNM  =  TP->NM  =  MAX_NM;
  fclose( FP_R );
  FREE_1C( buff );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
