/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include "StructType_Definition.h"
#include "function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  SIZE  50
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  END_PROGRAM( char *PRINTF, int N_REP, int c_END )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  printf( "                                                                  \n" );
  printf( "------------------------------------------------------------------\n" );
  for( i = 1; i <= N_REP; i++ )
    printf( "%s", PRINTF );
  printf( "------------------------------------------------------------------\n" );
  printf( "                                                                  \n" );
  if( c_END  ==  1 )
    exit(1);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  MPI_EXIT( TEMP TP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( TP.RANK == 0 ){
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Call MPI Exit Function\n" );
    END_PROGRAM( PRINTF, 10, 0 );
  }
  MPI_Barrier( MPI_COMM_WORLD );
  MPI_Finalize();
  exit(1);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  MPI_EXIT2()
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  printf( "Call MPI Exit 2 Function\n" );
  MPI_Barrier( MPI_COMM_WORLD );
  MPI_Finalize();
  exit(1);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
