/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  Remove_Character  ';'
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define SIZE 300
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  comment_remove( char *INPUTPARAMETER, char *OUTPUTPARAMETER )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  char RC=(char)Remove_Character;
  char *buff;
  FILE *fp_inputpara, *fp_outputpara;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  buff  =  MALLOC_1C( SIZE );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  if( ( fp_inputpara = fopen( INPUTPARAMETER, "r" ) )  ==  NULL ){
    puts( "Read Input Error!!" );
    exit( 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( ( fp_outputpara = fopen( OUTPUTPARAMETER, "w" ) )  ==  NULL ){
    puts( "Write Output Error!!" );
    exit( 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( fgets( buff, SIZE, fp_inputpara )  !=  NULL ){
    do{
      for( i = 0;  buff[i]  !=  '\0'; i++ ){
        if( buff[i]  ==  RC ){
          buff[i  ]  =  '\n';
          buff[i+1]  =  '\0';
          break;
        }
      }
      fprintf( fp_outputpara, "%s", buff );
    }while( fgets( buff, SIZE, fp_inputpara )  !=  NULL );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( fclose(fp_inputpara)  ==  EOF ){
    printf( "\nClose Input Error\n" );
    exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( fclose(fp_outputpara)  ==  EOF ){
    printf( "\nClose Output Error\n" );
    exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( buff );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------------*/
void  Remove_TempFile( char *TempFile )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  char *COMMAND;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  COMMAND  =  MALLOC_1C( SIZE );
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
  sprintf( COMMAND, "rm -rf %s", TempFile );
  system( COMMAND );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  FREE_1C( COMMAND );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
