/*-------------------------------------------------------------------------------*/
#define  N_OUTPUT_EV             5
#define  JUDG_CALCULATE_EVC_S    0.01
#define  JUDG_CALCULATE_EVC_P    1.0
#define  BIFURCATION_LINE_SELCT  0
#define  ERROR_BIF_LINE_S        0.000
#define  ERROR_BIF_LINE_P        0.000
#define  DELTA_DX                1.0E-08
#define  DELTA_PTB_X             1.0E-08
#define  DELTA_PTB_X2            1.0E-06
#define  DELTA_PTB_X11           1.0E-04
#define  DELTA_PTB_T11           1.0E-08
#define  DELTA_PTB_V11           1.0E-04
#define  DELTA_PTB_CP11          1.0E-04
#define  DELTA_PTB_X12           1.0E-04
#define  DELTA_PTB_T12           1.0E-08
#define  DELTA_PTB_V12           1.0E-04
#define  DELTA_PTB_CP12          1.0E-04
#define  DELTA_PTB_CP2           1.0E-08
#define  DELTA_PTB_EV            1.0E-04
#define  MAXCONVERGENCECHECK     1.0E+10
#define  MIN_UEV_CHECK           0.0
#define  OUTPUT_SV_CUT           50
#define  SIZE                    80
#define  LINESIZE                300
#define  N_NORM                  3 
#define  BFT_1                   1        /*  PForTC                           */
#define  BFT_2                   2        /*  HP                               */
#define  BFT_3                   3        /*  %dPForTC                         */
#define  BFT_4                   4        /*  %dHP                             */
#define  BFT_5                   5        /*  %dPForTC_%dHP                    */
#define  N_GNUPLOT               19
#define  N_S_SOL                 5
#define  N_S_EV                  7
#define  N_S_EVC                 9
#define  L_SOP_N                 1
#define  L_SOP_N_EP              2
#define  L_SOP_Lx                3
#define  L_SOP_dt                4
#define  L_SOP_NM                5
#define  L_SOP_PF                6
#define  L_SOP_EES               7
#define  L_SOP_NW                8
#define  L_SOP_ME                9
#define  L_REV_i_E               10
#define  L_SOP_N_VAR             20
#define  NM1                     1        /*  simplee NM                       */
#define  NM2                     2        /*  auto NM                          */
#define  NM3                     3        /*  pd                               */
#define  DISCRETE1               1        /*  Discrete  center                 */
#define  DISCRETE2               2        /*  Discrete  up wind                */
#define  MPEV1                   1        /*  1 order                          */
#define  MPEV2                   2        /*  2 order                          */
#define  PC1                     1        /*  difference                       */
#define  PC2                     2        /*  sm                               */
#define  BCS_1                   1        /*  Dirichlet   Boundary  Condition  */
#define  BCS_2                   2        /*  Neumann     Boundary  Condition  */
#define  BCS_3                   3        /*  Periodic    Boundary  Condition  */
#define  BCS_4                   4        /*  Dir-Neum    Boundary  Condition  */
#define  EES_D                   1        /*  Difference                       */
#define  EES_S_E                 2        /*  Spectrum Euler                   */
#define  EES_S_R                 3        /*  Spectrum Runge                   */
#define  EES_D_M                 4        /*  Difference Memory                */
#define  EES_S_E_M               5        /*  Spectrum Euler Memory            */
#define  EES_S_R_M               6        /*  Spectrum Runge Memory            */
#define  SS_1                    1        /*  Standing    Solution             */
#define  SS_2                    2        /*  Travelling  Solution             */
#define  SS_3                    3        /*  Standing    Breather  Solution   */
#define  SS_4                    4        /*  Travelling  Breather  Solution   */
#define  IS_1                    1
#define  IS_BC                   2        /*  Brunch Change                    */
#define  IS_EV                   7
#define  IS_EVC                  8
#define  IS_G                    9
/*-------------------------------------------------------------------------------*/
#define  MIN(A, B) ( (A)<(B) ? (A):(B) )
#define  MAX(A, B) ( (A)>(B) ? (A):(B) )
/*-------------------------------------------------------------------------------*/
