/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "function_declartion.h"
#include "read_write_file.h"
#include "constant.h"
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  initial_set2( TEMP *TP, double *par, double *BC, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int N_EP, N_VAR, N, NV, NA, Ns, BCS, IS;
  N_EP   =  TP->N_EP;
  N_VAR  =  TP->N_VAR;
  N      =  TP->N;
  NV     =  TP->NV;
  NA     =  TP->NA;
  Ns     =  TP->Ns;
  BCS    =  TP->BCS;
  IS     =  TP->IS;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  int    ti;
  double td, *EP, *SOP, *xx;
  FILE   *FP_R;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  EP   =  malloc_1d( N_VAR*Ns+NA );
  SOP  =  malloc_1d( N_VAR*Ns+NA );
  xx   =  malloc_1d( N_VAR*Ns+NA );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( IS  ==  1 ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
   for( i = 1; i <= N; i++ ){
      x[i  ]  =  0.000000000;
      x[i+N]  =  0.000000000;
      if( 10 <= i  &&  50>= i )
        x[i]  =  1.0;
      if( 10 <= i  &&  20>= i )
        x[i+N]  =  0.3;
    }
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  else if( IS == 2  ||  IS == 3 ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
    for( i = 1; i <= N_VAR*Ns+NA; i++ )
      fscanf( FP_R, "%d %lf %lf %lf %lf\n", \
              &ti, &SOP[i], &EP[i], &td, &xx[i] );
    fclose( FP_R );
    if( IS  ==  2 ){
      for( i = 1; i <= N_EP; i++ )
        par[i]  =  EP[i];
      for( i = 1; i <= N_VAR*2; i++ )
        BC[i]  =  SOP[i+L_SOP_N_VAR];
    }
    Generate_SV( *TP, BC, xx, x );
/*********************************************************************************/
/*
    int    i_center;
    double max_u;
    double *t_x;
    t_x  =  malloc_1d( NV );
    i_center  =  0;
    max_u     =  x[1];
    for( i = 2; i <= N; i++ ){
      if( max_u  <=  x[i] ){
        i_center  =  i-1;
        max_u     =  x[i];
      }
    }
    for( i = 1; i <= NV; i++ )
      t_x[i]  =  x[i];
//    if( i_center  <=  N/2 ){
//      for( i = 1; i <= N/2-i_center; i++ ){
//        x[i  ]  =  t_x[N/2+i_center+i  ];
//        x[i+N]  =  t_x[N/2+i_center+i+N];
//      }
//      for( i = N/2-i_center+1; i <= N; i++ ){
//        x[i  ]  =  t_x[i-N/2+i_center  ];
//        x[i+N]  =  t_x[i-N/2+i_center+N];
//      }
//    }
    for( i = 1; i <= i_center; i++ ){
      x[N+1-i  ]  =  t_x[i_center+1-i  ];
      x[N+1-i+N]  =  t_x[i_center+1-i+N];
    }
    for( i = i_center+1; i <= N; i++ ){
      x[N+1-i  ]  =  t_x[1  ];
      x[N+1-i+N]  =  t_x[1+N];
    }
    free_1d( t_x );
*/
/*********************************************************************************/
/*
    int    i_center;
    double min_u;
    double *t_x;
    t_x  =  malloc_1d( NV );
    i_center  =  0;
    min_u     =  x[1];
    for( i = 2; i <= N; i++ ){
      if( min_u  >=  x[i] ){
        i_center  =  i-1;
        min_u     =  x[i];
      }
    }
    for( i = 1; i <= NV; i++ )
      t_x[i]  =  x[i];
    for( i = 1; i <= i_center; i++ ){
      x[N+1-i+0*N]  =  t_x[i_center+1-i+0*N];
      x[N+1-i+1*N]  =  t_x[i_center+1-i+1*N];
      x[N+1-i+2*N]  =  t_x[i_center+1-i+2*N];
    }
    for( i = i_center+1; i <= N; i++ ){
      x[N+1-i+0*N]  =  t_x[1+0*N];
      x[N+1-i+1*N]  =  t_x[1+1*N];
      x[N+1-i+2*N]  =  t_x[1+2*N];
    }
    free_1d( t_x );
*/
/*********************************************************************************/
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if  ( TP->T   == 1.0 )   TP->T   = x[NV+1];
  else                     TP->T   = 1.0;
                           TP->T   = 1.0;
  if  ( TP->VEL == 1.0 )   TP->VEL = x[NV+2];
  else                     TP->VEL = 0.0;
printf("T=%lf VEL=%lf\n",TP->T,TP->VEL);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( EP  );
  free_1d( SOP );
  free_1d( xx  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/





/*-------------------------------------------------------------------------------*/
void  initial_set1( TEMP *TP )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int BCS, IS;
  BCS  =  TP->BCS;
  IS   =  TP->IS;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i;
  int    N_S;
  double *SOP;
  char   *line;
  FILE   *FP_R=NULL;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  SOP   =  malloc_1d( TP->N_VAR*(TP->N+1)+TP->NA );
  line  =  MALLOC_1C( LINESIZE                   );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( IS  ==  1 ){
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( IS == 2  ||  IS == 3 ){
    FP_R  =  fopen_mode( READ_INITIALDATA, 'r' );
    fgets( line, (int)LINESIZE, FP_R );
    N_SPLIT( " ", line, &N_S );
    FREE_1C( line );
    fseek( FP_R, 0, SEEK_SET );
    double *data;
    data  =  malloc_1d( N_S );
    for( i = 1; i <= L_SOP_N_VAR; i++ ){
      SPLIT_READ_DATA( N_S, FP_R, data );
      SOP[i]  =  data[2];
    }
    free_1d( data );
    fclose( FP_R );
    TP->N      =  (int)SOP[L_SOP_N];
    TP->N_EP   =  (int)SOP[L_SOP_N_EP];
    TP->N_VAR  =  (int)SOP[L_SOP_N_VAR];
    if( IS  !=  3 ){
      TP->Lx  =       SOP[L_SOP_Lx];
      TP->dt  =       SOP[L_SOP_dt];
      TP->NW  =  (int)SOP[L_SOP_NW];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else{
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Initial Select Mistake !! (%d)\n", IS );
    END_PROGRAM( PRINTF, 10, 1 );
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  TP->Ns  =  TP->N + 1;
  TP->dx  =  TP->Lx / TP->N;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if     ( BCS == 1 )  TP->N  =  TP->N-1;
  else if( BCS == 2 )  TP->N  =  TP->N+1;
  else if( BCS == 3 )  TP->N  =  TP->N;
  else if( BCS == 4 )  TP->N  =  TP->N;
  else{
    char *PRINTF;
    PRINTF  =  MALLOC_1C( SIZE );
    sprintf( PRINTF, "Bounduary Condition Select Mistake !! (%d)\n", BCS );
    END_PROGRAM( PRINTF, 10, 1 );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( SOP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
