c clcegnv.f
c
	subroutine clcegnv(nm, n, t_a,
     &                     eigenr, eigeni, t_eigv, k1, k, judg )
c
c	Calculate eigenvalues
c
	implicit real*8 (a-h, o-z)
	logical select(n)
	real*8  t_a(nm*nm)
	real*8  a(nm, n)
	real*8  fv1(n), fv2(n), fv3(n)
	real*8  fm1(nm, n)
	integer iv1(n), k1(n)
	real*8  eigenr(n), eigeni(n), eigv(nm,n)
	real*8  t_eigv(nm*nm)
        real*8  judg
c
	do i = 1, nm
	  do j = 1, nm
	    a(i,j)  =  t_a(Nm*(i-1)+j)
	  end do
	end do
c
	call balanc(nm, n, a, is1, is2, fv1)
	call elmhes(nm, n, is1, is2, a, iv1)
	do i = 1, nm
	  do j = 1, n
	    fm1(i,j)  =  a(i,j)
	  end do
	end do
	call hqr(nm,n,is1,is2,fm1,eigenr,eigeni,ierr)
c
	if(ierr .eq. 0) then
	  k = 0
	  do i = 1, n
	    if( abs(eigenr(i))  .le. judg ) then
	      k = k + 1
	      k1(k) = i
	      select(i) = .true.
	    else 
		select(i) = .false.
	    end if
	  end do
	  MM = nm
	  call invit(nm, n, a, eigenr, eigeni, select, 
     &				MM,M,eigv,ierr,fm1,fv2,fv3)
	  call elmbak(nm, is1, is2, a, iv1, M, eigv)
	  call balbak(nm, n, is1, is2, fv1,M,eigv)
	else
	  write(6, 5001)
	end if
c
	do i = 1, nm
	  do j = 1, nm
	    t_eigv(Nm*(i-1)+j)  =  eigv(i,j)
	  end do
	end do
c
	return
c
 5001	format(1H ,'Error occured at hqr2() in clcegn.')
	end
