/*-------------------------------------------------------------------------------*/
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_1n3pC
      ( int N, double *RS, double **L, double **U, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double sum;
  double *z;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  z  =  alloc_1d_double( N+1 );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  z[1]  =  RS[1] / L[1][1];
  for( i = 2; i <= N-1; i++ )
    z[i]  =  ( RS[i]-L[2][i]*z[i-1] ) / L[1][i];
  sum  =  0.0;
  for( i = 1; i <= N-1; i++ )
    sum  +=  L[3][i]*z[i];
  z[N  ]  =  ( RS[N]-sum ) / L[3][N];
  x[N  ]  =  z[N];
  x[N-1]  =  z[N-1]-U[2][N-1]*x[N];
  for( i = N-2; i >= 1; i-- )
    x[i]  =  z[i] - U[1][i] * x[i+1] - U[2][i] * x[N];
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_double( z );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
