/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_1n3pDN( int N, double **a, double **L, double **U )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  L[1][1]  =  a[1][1];
  for( i = 2; i <= N; i++ )
    L[2][i]  =  a[i][i-1];
  for( i = 1; i <= N-1; i++ ){
    U[1][i  ]  =  a[i  ][i+1] / L[1][i];
    L[1][i+1]  =  a[i+1][i+1] - U[1][i] * L[2][i+1];
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
