/*-------------------------------------------------------------------------------*/
void  LU_Decomposition_1nF( int N, double **a, double **L, double **U )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j, k;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  for( i = 1; i <= N; i++ ){
    for( j = 1; j <= N; j++ ){
      L[i][j]  =  0.0;
      U[i][j]  =  0.0;
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( j = 1; j <= N; j++ ){
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = 1; i <= j; i++ ){
      sum  =  0.0;
      for( k = 1; k <= i-1; k++ )
        sum  +=  L[i][k] * U[k][j];
      U[i][j]  =  a[i][j] - sum;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    for( i = j+1; i <= N; i++ ){
      sum  =  0.0;
      for( k = 1; k <= j-1; k++ )
        sum  +=  L[i][k] * U[k][j];
      L[i][j]  =  (a[i][j]-sum) / U[j][j];
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
