/*-------------------------------------------------------------------------------*/
#include <stdio.h>
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  comment_remove( char *INPUTPARAMETER, char *OUTPUTPARAMETER );
void  Remove_TempFile( char *TempFile );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  DataNum( char *READ_DATA, int *DataNum );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  read_OperationParameter( char *READ_OP, int N_OP, int *OP_int, double *OP_double );
void  read_EquationParameter( char *READ_EP, int N_EP, double *par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
FILE  *fopen_mode( char *FILENAME, int ModeSet );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  END_PROGRAM( char *PRINTF, int N_REP, int c_END );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  GNUPLOT_DRAW_SELECT( int N_G, int GSD, int *c_G );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  F_Function( int N, double *par, double *x, double *f );
void  G_Function( int N, double *par, double *x, double *g );
void  H_Function( int N, double *par, double *x, double *h );
void  PartialDiff_Function_FP( int N_EP, int N, int CP, double *par, double *x, double *PDF );
void  PartialDiff_Function_GP( int N_EP, int N, int CP, double *par, double *x, double *PDF );
void  PartialDiff_Function_FU( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_FV( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_GU( int N, int Nm, double *par, double *x, double *PDF );
void  PartialDiff_Function_GV( int N, int Nm, double *par, double *x, double *PDF );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  LU_Decomposition_1n3pDN( int N, double **a, double **L, double **U );
void  Calculate_Solution_1n3pDN( int N, double *RS, double **L, double **U, double *x );
void  LU_Decomposition_1n3pC( int N, double **a, double **L, double **U );
void  Calculate_Solution_1n3pC( int N, double *RS, double **L, double **U, double *x );
void  LU_Decomposition_1nF( int N, double **a, double **L, double **U );
void  Calculate_Solution_1nF( int N, double *RS, double **L, double **U, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  initial_dot( int N, double *d_x, double *p_x, double *x );
void  normalize_dot_x( int N, double *d_x );
void  RightSide_Of_Dot( int N, double *dot_RS );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Sort_NearZeroEV( int Nm, double *REV, double *IEV );
void  Sort_NearOneEV( int Nm, double *REV, double *IEV );
void  Sort_AscendingSequence( int Nm, double *REV, double *IEV );
void  Sort_AscendingSequence_RIEV( int Nm, double *REV, double *IEV );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Arrange_SV( int N, int Nm , int nm, int NN, int NM, int BCS, \
                  double BC_00_U, double BC_N1_U, double BC_00_V , double BC_N1_V, \
                  double *x     , double *xx      );
void  Arrange_SV1( int N, int Nm, int nm, int NN, int NM, int BCS, double *xx, double *x );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
void  N_SPLIT( char *Split_Character, char *Split_Target, int *N_Split_Target );
void  SPLIT( int N_Split          , int NMax_Split    , \
             char *Split_Character, char *Split_Target, char **data );
void  SPLIT_READ_DATA( int N, FILE *fp, double *data );
void  SPLIT_WRITE_DATA( int N_Data       , FILE   *fp  , \
                        int *DeletingData, double *data, char **SubData );
void  SPLIT_WRITE_GNUPLOT
      ( FILE *fp      , int step      ,double data_DP, \
        char *EchoName, char *FileName, int N_SC12   , \
        char *C10     , char **C11    , char **C12   , char **C13, char **C14, \
        char *C2   );
void  SPLIT_WRITE_PRINT
      ( FILE *fp , char *FNData, char *FNLpr, char *lpr , char *PostScript, \
        int N_SC0, int N_SC12  , \
        char **C0, char *C10   , char **C11 , char **C12, char **C13, char **C14 );
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int     *alloc_1d_int(int n1);
void    free_1d_int(int *i);
double  *alloc_1d_double(int n1);
void    free_1d_double(double *d);
char    *alloc_1d_char(int n1);
void    free_1d_char(char *c);
int     **alloc_2d_int(int n1, int n2);
void    free_2d_int(int **ii);
double  **alloc_2d_double(int n1, int n2);
void    free_2d_double(double **dd);
char    **alloc_2d_char(int n1, int n2);
void    free_2d_char(char **cc);
int     ***alloc_3d_int(int n1, int n2, int n3);
void    free_3d_int(int ***iii);
double  ***alloc_3d_double(int n1, int n2, int n3);
void    free_3d_double(double ***ddd);
char    ***alloc_3d_char(int n1, int n2, int n3);
void    free_3d_char(char ***ccc);
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  CLCEGN( int Nm, int N, double **a, double *REV, double *IEV );
void  BALANC( int Nm, int N, double **A, int *low, int *igh );
void  ELMHES( int Nm, int N, int *low, int *igh, double **a );
void  HQR( int Nm    , int N      , int *low   , int *igh, \
           double **a, double *REV, double *IEV, int *ERR  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  ilucgs1_( int *, int *, int *, int *, int *, double *, double *, double *, int * );
void  clcegn_( int *, int *, double *, double *, double * );
void  clcegnv_( int *, int *, double *, double *, double *, double *, int *, int *, double * );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  glu1_( int *, int *, double *, int * );
void  gslv1_( int *, int *, double *, double * );
void  glu2_( int *, int *, int *, double *, int * );
void  glu4_( int *, int *, int *, double *, int * );
void  gslv4_( int *, int *, int *, double *, double * );
void  glu11_( int *, int *, int *, double *, int * );
void  gslv11_( int *, int *, int *, double *, double * );
/*-------------------------------------------------------------------------------*/
