/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  normalize_dot_x( int N, double *d_x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i;
  double sum;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  sum  =  0.0;
  for( i = 1; i <= N; i++ )
    sum  +=  d_x[i] * d_x[i];

  if( sum  !=  0.0 ){
    for( i = 1; i <= N; i++ )
      d_x[i]  /=  sqrt( sum );
  }else{
    printf( "\n Sum Direction Vector divide by 0 !! \n" );
    exit(1);
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
