/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Calculate_Solution_1n3dDNC( TEMP TP, double *RS, double **a, double *x )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    i, Vi, i_VAR;
  double sum;
  double *z;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  z  =  malloc_1d( TP.N );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( TP.BCS == 1  ||  TP.BCS == 2   ||  TP.BCS == 4 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      z[1]  =  RS[1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N+Vi; i++ )
        z[i-Vi]  =  ( RS[i] - a[2][i] * z[i-1-Vi] ) / a[1][i];
      x[TP.N+Vi]  =  z[TP.N];
      for( i = TP.N-1+Vi; i >= 1+Vi; i-- )
        x[i]  =  z[i-Vi] - a[3][i] * x[i+1];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  else if( TP.BCS  ==  3 ){
    for( i_VAR = 1; i_VAR <= TP.N_VAR; i_VAR++ ){
      Vi  =  (i_VAR-1)*TP.N;
      z[1]  =  RS[1+Vi] / a[1][1+Vi];
      for( i = 2+Vi; i <= TP.N-1+Vi; i++ )
        z[i-Vi]  =  ( RS[i]-a[2][i]*z[i-1-Vi] ) / a[1][i];
      sum  =  0.0;
      for( i = 1+Vi; i <= TP.N-1+Vi; i++ )
        sum  +=  a[4][i]*z[i-Vi];
      i        =  TP.N + Vi;
      z[i-Vi]  =  ( RS[i]-sum ) / a[4][i];
      x[i   ]  =  z[i-Vi];
      x[i-1 ]  =  z[i-1-Vi]-a[5][i-1]*x[i];
      for( i = TP.N-2+Vi; i >= 1+Vi; i-- )
        x[i]  =  z[i-Vi] - a[3][i] * x[i+1] - a[5][i] * x[TP.N+Vi];
    }
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d( z );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
