c clcegnv.f
c
	subroutine clcegnv(NV, n, np, t_a,
     &                     eigenr, eigeni, t_eigv, k1, k, judg )
c
c	Calculate eigenvalues
c
	implicit real*8 (a-h, o-z)
	logical select(n)
	real*8  t_a(NV*NV)
	real*8  a(NV, n)
	real*8  fv1(n), fv2(n), fv3(n)
	real*8  fm1(NV, n)
	integer iv1(n), k1(n)
	real*8  eigenr(n), eigeni(n), eigv(NV,n)
	real*8  t_eigv(NV*NV)
        real*8  judg
c
	do i = 1, NV
	  do j = 1, NV
	    a(i,j)  =  t_a(NV*(i-1)+j)
	  end do
	end do
c
	call balanc(NV, n, a, is1, is2, fv1)
	call elmhes(NV, n, is1, is2, a, iv1)
	do i = 1, NV
	  do j = 1, n
	    fm1(i,j)  =  a(i,j)
	  end do
	end do
	call hqr(NV,n,is1,is2,fm1,eigenr,eigeni,ierr)
c
	if(ierr .eq. 0) then
	  k = 0
	  if( np .eq. 0 ) then
	    do i = 1, n
	      if( abs(eigenr(i)) .le. judg ) then
	        k = k + 1
	        k1(k) = i
	        select(i) = .true.
	      else 
	        select(i) = .false.
	      end if
	    end do
	  else
	    do i = 1, n
	      if( abs(sqrt(eigenr(i)*eigenr(i)+eigeni(i)*eigeni(i))-1.d0)
     &            .le. judg ) then
	        k = k + 1
	        k1(k) = i
	        select(i) = .true.
	      else 
	        select(i) = .false.
	      end if
	    end do
	  end if
	  MM = NV
	  call invit(NV, n, a, eigenr, eigeni, select, 
     &				MM,M,eigv,ierr,fm1,fv2,fv3)
	  call elmbak(NV, is1, is2, a, iv1, M, eigv)
	  call balbak(NV, n, is1, is2, fv1,M,eigv)
c	else
c	  write(6, 5001)
	end if
c
	do i = 1, NV
	  do j = 1, NV
	    t_eigv(NV*(i-1)+j)  =  eigv(i,j)
	  end do
	end do
c
	return
c
c5001	format(1H ,'Error occured at hqr2() in clcegn.')
	end
