/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <mpi.h>
#include "StructType_Definition.h"
#include "function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Partition_1dim( int PROCS, int RANK, int Ni, int Nj, int *start, int *end, int *len, int *disp )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int i, j, add_nlen;
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( Nj % PROCS  ==  0 ){
    for( i = 1; i <= PROCS+1; i++ ){
      len[i]   =  Ni * (Nj/PROCS);
      disp[i]  =  (i-1) * Ni * (Nj/PROCS);
    }
  }else{
    len[1]   =  Ni * (Nj/PROCS);
    disp[1]  =  0;
    add_nlen  =  Nj - PROCS*(Nj/PROCS);
    for( i = 1; i <= add_nlen; i++ ){
      len[i+1]   =  Ni * (Nj/PROCS+1);
      disp[i+1]  =  disp[i] + len[i];
    }
    for( i = add_nlen+1; i <= PROCS; i++ ){
      len[i+1]   =  Ni * (Nj/PROCS);
      disp[i+1]  =  disp[i] + len[i];
    }
  }
  *start  =  disp[RANK+1] / Ni + 1;
  *end    =  disp[RANK+2] / Ni;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
