/*-------------------------------------------------------------------------------*/
#include "StructType_Definition.h"
#include "LIB/function_declartion.h"
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  initial_set1( TEMP *TP );
void  initial_set2( TEMP *TP, double *par, double *BC, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Parameter_OutPut( TEMP TP, double *par );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Gnuplot_InitialCommand( TEMP *TP, int *c_G );
void  Gnuplot_Draw( TEMP TP, int *c_G );
void  Gnuplot_DrawCommand( TEMP TP, FILE *GP, int SELECT );
void  Gnuplot_Close( TEMP *TP );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Diffusion( TEMP TP, double *par );
void  Reaction( TEMP TP, double *par, double *x, double *F );
void  M_1n1v3dDNC( TEMP TP, double *par, double *BC, double **a );
void  RS_1n1v3dDNC( TEMP TP, double *par, double *BC, double *x, double *F, double *RS );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  LU_Decomposition_1n3dDNC( TEMP TP, double **a );
void  Calculate_Solution_1n3dDNC( TEMP TP, double *RS, double **a, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  RK4_SM( TEMP TP, double *par, double *x );
void  RK4_SM2( TEMP TP, double *par, double *x );
void  RK4_SM3( TEMP TP, double *par, double *x );
void  RK4_SM4( TEMP TP, double *par, double *x );
void  RK45_SM( TEMP TP, double *par, double *x );
void  RK5_SM( TEMP TP, double *par, double *x );
void  Sub_RK4( TEMP TP, double *par, double *x, double *Wx, int *SCT, double *td, double *RK );
void  AB_SM_INI( TEMP TP, double *par, double *pF, double *x );
void  AB3_SM( TEMP TP, double *par, double *pF, double *x );
void  AB4_SM( TEMP TP, double *par, double *pF, double *x );
void  AB5_SM( TEMP TP, double *par, double *pF, double *x );
void  AB6_SM( TEMP TP, double *par, double *pF, double *x );
void  EM_SM( TEMP TP, double *par, double *x );
void  MEM_SM( TEMP TP, double *par, double *x );
void  RDFT( int N, int NW, int *SCT, double *td, double *wx );
void  IRDFT( int i_VAR, int N, int *SCT, double *td, double *wx, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  Velocity_Measurement( TEMP *TP, double *BC, double *x );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  output( TEMP TP, double *par, double *BC, double *x, int WriteMode );
void  output2( TEMP TP, double *par, double *x, int WriteMode );
void  Output_Final( TEMP TP, double *par, double *BC, double *x, char *FILENAME, int WriteMode );
void  Calculate_Norm( TEMP TP, double *t_x, double *norm );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void  Generate_OPEP( TEMP TP, double *par, double *BC, double *SOP, double *EP );
void  Generate_SV( TEMP TP, double *BC, double *xx, double *x );
void  Generate_tSV( TEMP TP, double *BC, double *x, double *xx );
void  Generate_BC_Space( TEMP TP, double *BC, double *x, double *BCX );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void  LU_Decomposition_EE( TEMP TP, double **a );
void  Calculate_Solution_EE( TEMP TP, double *RS, double **a, double *x );
void  LU_Decomposition_F( int N, double **a );
void  Calculate_Solution_F( int N, double *RS, double **a, double *x );
/*-------------------------------------------------------------------------------*/
