/*-------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../LIB/function_declartion.h"
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define  LINESIZE      300
#define  COMMANDSIZE   100
#define  GCSIZE        500
#define  FILENAMESIZE  100
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
int  main( int argc, char **argv )
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  int    IS;
  int    OPND;
  double sleep;
  char   *C0;
  char   *C11;
  char   *C12;
  char   *C13;
  char   *C10;
  int    DP;
  char   *DD;
  char   *EN;
  char   *RD;
  char   *MD;
  char   *W_AF;
  char   *SC_D;
  char   *SC_C0;
  char   *SC_C11;
  char   *SC_C12;
  char   *SC_C13;
  char   *SC_DD;
  char   *lpr;
  char   *PS;
  char   *SSOG;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  IS      =  atoi( argv[1 ] );   //  InitialSelect
  OPND    =  atoi( argv[2 ] );   //  OutPut_NumData
  sleep   =  atof( argv[3 ] );
  C0      =        argv[4 ]  ;   //  command0
  C11     =        argv[5 ]  ;   //  command1_1
  C12     =        argv[6 ]  ;   //  command1_2
  C13     =        argv[7 ]  ;   //  command1_3
  C10     =        argv[8 ]  ;   //  command1_0
  DP      =  atoi( argv[9 ] );   //  DivsionPoint
  DD      =        argv[10]  ;   //  DeletingData
  EN      =        argv[11]  ;   //  EchoName
  RD      =        argv[12]  ;   //  Read_Data
  MD      =        argv[13]  ;   //  Making_Directory
  W_AF    =        argv[14]  ;   //  Write_ActionFile
  SC_D    =        argv[15]  ;   //  Split_Character_Data
  SC_C0   =        argv[16]  ;   //  Split_Character_Command0
  SC_C11  =        argv[17]  ;   //  Split_Character_Command11
  SC_C12  =        argv[18]  ;   //  Split_Character_Command12
  SC_C13  =        argv[19]  ;   //  Split_Character_Command13
  SC_DD   =        argv[20]  ;   //  Split_Character_DeletingData
  lpr     =        argv[21]  ;
  PS      =        argv[22]  ;   //  PostScript
  SSOG    =        argv[23]  ;   //  Select_Summons_Of_Gnuplot
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  char *COMMAND;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  COMMAND  =  alloc_1d_char( COMMANDSIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( mkdir(MD,0000755)  !=  0 ){
    sprintf( COMMAND, "rm -rf %s", MD );
    system( COMMAND );
    mkdir(MD,0000755);
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  if( ! strcmp(lpr,"ps") )
    lpr  =  "";
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int  i;
  int  N_SC0, N_SC11, N_SC12, N_SC13;   //  N_Split_Commnad??
  char *t_C;
  char **C0_Data, **C11_Data, **C12_Data, **C13_Data, **C14_Data;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_C  =  alloc_1d_char( GCSIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  strcpy( t_C, C0  );  N_SPLIT( SC_C0 , t_C, &N_SC0  );
  strcpy( t_C, C11 );  N_SPLIT( SC_C11, t_C, &N_SC11 );
  strcpy( t_C, C12 );  N_SPLIT( SC_C12, t_C, &N_SC12 );
  strcpy( t_C, C13 );  N_SPLIT( SC_C13, t_C, &N_SC13 );
  C0_Data   =  alloc_2d_char( N_SC0 +1, GCSIZE );
  C11_Data  =  alloc_2d_char( N_SC12+1, GCSIZE );
  C12_Data  =  alloc_2d_char( N_SC12+1, GCSIZE );
  C13_Data  =  alloc_2d_char( N_SC12+1, GCSIZE );
  C14_Data  =  alloc_2d_char( N_SC12+1, GCSIZE );
  strcpy( t_C, C0  );  SPLIT( N_SC0 , N_SC0 , SC_C0 , t_C, C0_Data  );
  strcpy( t_C, C11 );  SPLIT( N_SC11, N_SC12, SC_C11, t_C, C11_Data );
  strcpy( t_C, C12 );  SPLIT( N_SC12, N_SC12, SC_C12, t_C, C12_Data );
  strcpy( t_C, C13 );  SPLIT( N_SC13, N_SC12, SC_C13, t_C, C13_Data );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= N_SC12-1; i++ )
    C14_Data[i]  =  ",";
  C14_Data[N_SC12]  =  "\n";
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char( t_C );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  char *C2;     //  command_2
  FILE *fp_G;   //  FilePoint_Gnuplot
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  C2  =  alloc_1d_char( COMMANDSIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fp_G  =  fopen_mode( W_AF, 'w' );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  for( i = 1; i <= N_SC0; i++ )
    fprintf( fp_G, "%s\n", C0_Data[i] );
  fprintf( fp_G, "! echo\n"                                                      );
  fprintf( fp_G, "! echo '---------------------------------------------------'\n");
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( IS  ==  1 )
    sprintf( C2, "pause -1\n" );
  else if( IS == 2  ||  IS == 3 )
    sprintf( C2, "!echo; sleep %lf\n", sleep );
  else{
    printf( "Mistake Initial Select !! (IS)\n" );
    exit(1);
  }
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int  N_SD;   //  Num_Split_Data
  char *t_line;
  FILE *fp_RD;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_line  =  alloc_1d_char( LINESIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fp_RD  =  fopen_mode( RD, 'r' );
  fgets( t_line, LINESIZE, fp_RD );
  fclose( fp_RD );
  N_SPLIT( SC_D, t_line, &N_SD );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char( t_line );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  int  N_SDD;   //  N_Split_DeletingData
  char *t_DD;
  char **t_DD_cData;
  int  *t_DD_iData;
  int  *DD_Data;
  char **SubData;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  t_DD     =  alloc_1d_char( GCSIZE    );
  DD_Data  =  alloc_1d_int ( N_SD+1    );
  SubData  =  alloc_2d_char( N_SD+1, 4 );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  strcpy( t_DD, DD );
  N_SPLIT( SC_DD, t_DD, &N_SDD );
  t_DD_cData  =  alloc_2d_char( N_SDD+1, GCSIZE );
  strcpy( t_DD, DD );
  SPLIT( N_SDD, N_SDD, SC_DD, t_DD, t_DD_cData );
  t_DD_iData  =  alloc_1d_int( N_SDD+1 );
  for( i = 1; i <= N_SDD; i++ )
    t_DD_iData[i]  =  atoi( t_DD_cData[i] );
  for( i = 1; i <= N_SD; i++ ){
    DD_Data[i]  =  0;
    SubData[i]  =  " ";
  }
  SubData[N_SD]  =  "\n";
  for( i = 1; i <= N_SDD; i++ )
    if( t_DD_iData[i] >= 1 )
      DD_Data[t_DD_iData[i]]  =  1;
  for( i = N_SDD; i >= 2; i-- ){
    if( DD_Data[i]  ==  1 )
      SubData[i-1]  =  "\n";
    else
      break;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char( t_DD       );
  free_2d_char( t_DD_cData );
  free_1d_int ( t_DD_iData );
/*-------------------------------------------------------------------------------*/
 
/*-------------------------------------------------------------------------------*/
  int    j;
  int    step;
  int    OCD;          //  OneCycleData;
  double p_DPV, DPV;   //  DivsionPointValue
  double *data;
  char   *FND;         //  FileNameData
  char   *FNP;         //  FileNamePrint
  char   *FNL;         //  FileNamelpr
  FILE   *fp_D;        //  FilePoint_Write_Data
  FILE   *fp_PC;       //  FilePoint_PrintCommand
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  data  =  alloc_1d_double( N_SD+1 );
  FND   =  alloc_1d_char  ( FILENAMESIZE );
  FNP   =  alloc_1d_char  ( FILENAMESIZE );
  FNL   =  alloc_1d_char  ( FILENAMESIZE );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  fp_RD  =  fopen_mode( RD, 'r' );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  step  =  0;
  SPLIT_READ_DATA( N_SD, fp_RD, data );
  while( 1 ){
    OCD  =  0;
    sprintf( FND, "%s/%d_%lf", MD, step, data[DP] );
    sprintf( FNP, "%s/p%d"   , MD, step           );
    sprintf( FNL, "%s/l%d"   , MD, step           );
    fp_D   =  fopen_mode( FND, 'w' );
    fp_PC  =  fopen_mode( FNP, 'w' );
    SPLIT_WRITE_DATA( N_SD, fp_D, DD_Data, data, SubData );
    SPLIT_WRITE_GNUPLOT( fp_G, step, data[DP], EN, FND, N_SC12, C10, C11_Data, C12_Data, C13_Data, C14_Data, C2 );
    SPLIT_WRITE_PRINT( fp_PC, FND, FNL, lpr, PS, N_SC0, N_SC12, C0_Data, C10, C11_Data, C12_Data, C13_Data, C14_Data );
    fclose( fp_PC );
    if( IS == 2  &&  step == 0 )
      fprintf( fp_G, "pause -1 \"Hit Ritturn Key !!\"\n" );
    p_DPV  =  DPV  =  data[DP];
    OCD ++;
    while( 1 ){
      SPLIT_READ_DATA( N_SD, fp_RD, data );
      if( feof(fp_RD)  !=  0 ){
        fclose( fp_D );
        goto END;
      }
      DPV  =  data[DP];
      if( p_DPV  !=  DPV )
        break;
      SPLIT_WRITE_DATA( N_SD, fp_D, DD_Data, data, SubData );
      p_DPV  =  DPV;
      OCD ++;
    }
    fclose( fp_D );
    for( i = 2;  i<= OPND; i++ ){
      for( j = 2;  j<= OCD; j++ )
        SPLIT_READ_DATA( N_SD, fp_RD, data );
      SPLIT_READ_DATA( N_SD, fp_RD, data );
      if( feof(fp_RD)  !=  0 )
        goto END;
    }
    step ++;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  END:
  fclose( fp_RD );
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
  fprintf( fp_G, "! echo '---------------------------------------------------'\n");
  fprintf( fp_G, "! echo\n"                                                      );
  if( IS  ==  2 )
    fprintf( fp_G, "pause -1 \"Hit Ritturn Key !!\"\n" );
  fclose( fp_G  );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if( ! strcmp(SSOG,"yes") ){
    printf( "                                                                  \n" );
    printf( "------------------------------------------------------------------\n" );
    printf( "During a summons of gnuplot !!                                    \n" );
    printf( "Waiting ...                                                       \n" );
    printf( "------------------------------------------------------------------\n" );
    sprintf( COMMAND, "gnuplot %s", W_AF );
    system( COMMAND );
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  free_1d_char  ( COMMAND  );
  free_1d_char  ( C2       );
  free_2d_char  ( C0_Data  );
  free_2d_char  ( C11_Data );
  free_2d_char  ( C12_Data );
  free_2d_char  ( C13_Data );
  free_2d_char  ( C14_Data );
  free_1d_int   ( DD_Data  );
  free_2d_char  ( SubData  );
  free_1d_double( data     );
  free_1d_char  ( FND      );
  free_1d_char  ( FNP      );
  free_1d_char  ( FNL      );
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  return 0;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
}
/*-------------------------------------------------------------------------------*/
